// Force Trick Panel by Yellow/@GlowingTail
-- Makes the player activate their trick state without the need of a panel, call this with ACS.
local version = 2
if not ForceTrickPanel rawset(_G, 'ForceTrickPanel', {build = version}) elseif ForceTrickPanel and ForceTrickPanel.build <= version return end
print("\132Force Trick Panel\128 has been loaded. \134[Build #"..ForceTrickPanel.build.."]")
----------------------------------------------------------------------------------------------------

local TRICKSTATE_NONE = 0
local TRICKSTATE_READY = 1
local ARG_TRICKFAIL, ARG_COLOR = 1, 2

local function getSkinColor(color)
	return pcall(do return skincolors[color] end) and color or 1
end

addHook('SpecialExecute', function(entity, args)
    if not (entity.mo and entity.mo.valid and entity.mo.player) or (entity.mo.player.spectator) return end
    local pmo = entity.mo
    local p = pmo.player

    if (FixedDiv(pmo.momz * P_MobjFlip(pmo), mapobjectscale) < 10 * FRACUNIT) return end
    if not (p.trickindicator and p.trickindicator.valid) or (p.trickpanel) return end

    p.trickpanel = TRICKSTATE_READY
    p.pflags = $ | PF_TRICKDELAY

	p.trickindicator.scale = 0
    p.trickindicator.color = getSkinColor(args[ARG_COLOR])
    p.trickpanelfallsafe = args[ARG_TRICKFAIL] and true or false
end, 'FORCETRICKPANEL')

addHook('PreThinkFrame', do
	for p in players.iterate do
		if not (p.mo and p.mo.valid and (p.trickpanel == TRICKSTATE_READY) and p.trickpanelfallsafe and not p.spectator) continue end

		if FixedDiv(p.mo.momz, mapobjectscale) < -8 * FRACUNIT
			p.trickpanel = TRICKSTATE_NONE
            p.trickpanelfallsafe = false
		end
	end
end)

addHook('MobjThinker', function(indicator)
	if not (indicator and indicator.valid and indicator.tracer and indicator.tracer.valid and indicator.target and indicator.target.valid and indicator.target.player and indicator.target.player.valid) return end
	local pmo = indicator.target
	local p = pmo.player
	local layered = indicator.tracer

	layered.color = indicator.color
	p.trickindicator = indicator

	if (p.trickpanel == TRICKSTATE_READY) and (indicator.state == S_INVISIBLE or layered.state == S_INVISIBLE)
		indicator.state = S_TRICKINDICATOR_UNDERLAY
		layered.state = S_TRICKINDICATOR_OVERLAY
	end
end, MT_TRICKINDICATOR)